#import <Cocoa/Cocoa.h>
#import "RParsedExpression.h"

//A hinting controller handles the stuff required to manage
//all of the hinting and completion infrastructure for both
//script editors and consoles that use NSTextViews.
@interface RHintingController : NSWindowController {
	IBOutlet NSTextView  *textView;
	IBOutlet NSButton    *helpButton;
	IBOutlet NSTextField *statusText;	
	
	BOOL               deleteBackward,hinting;
	RParsedExpression *hintExpr;
	RParsedExpression *compExpr;
	NSString          *hintFunName;
	NSDictionary      *hintAttrs;
	NSRange            currentFn;	
	
	NSInteger lineStart;
}

@property(readwrite) BOOL      hinting;
@property(readwrite) NSInteger lineStart;

- (IBAction)helpButton:(id)sender;
- (NSTextStorage*)textStorage;


@end
