//
//  RParsedExpression.m
//  R
//
//  Created by Byron Ellis on 1/20/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "RParsedExpression.h"
#include <Rinternals.h>


//Doing a DFS should organize things positionally in the array.
void DFS_Find(SEXP vec,NSMutableArray *array,NSInteger depth) {
	SEXP tmp,orig = vec;
	NSInteger i;
//	NSLog(@"DFS depth %d (%d) 0x%x",depth,length(vec),vec);
//	Rf_PrintValue(vec);
	switch(TYPEOF(vec)) {
	case EXPRSXP:
//		NSLog(@"An Expression");
//		Rf_PrintValue(VECTOR_ELT(vec,0));
		DFS_Find(VECTOR_ELT(vec,0),array,depth+1);
		break;
	case LANGSXP:
//		NSLog(@"Language List");
		i=0;
		do {
			tmp = CAR(vec);vec = CDR(vec);
			if(TYPEOF(tmp) == SYMSXP && tmp == install("._")) {
//				Rf_PrintValue(orig);
//				Rf_PrintValue(tmp);
				[array addObject:[NSDictionary dictionaryWithObjectsAndKeys:[NSValue valueWithPointer:orig],@"SEXP",[NSNumber numberWithUnsignedInteger:i],@"Position",nil]];
			} else
				DFS_Find(tmp,array,depth+1);
			++i;
		} while(vec != R_NilValue);
		break;
	default:
		break;
	}
}

@implementation RParsedExpression
- (id)initWithPointer:(void*)aPtr {
	if(nil == [super initWithPointer:aPtr]) return nil;
	//Find and record the position of the ._ elements
	args = [[NSMutableArray alloc] init];
	DFS_Find((SEXP)aPtr,args,0);
	return self;
}

- (void)setArgument:(NSUInteger)anArg value:(RValue*)value {
	NSDictionary *desc = [args objectAtIndex:anArg];
	int i=0,pos = [(NSNumber*)[desc objectForKey:@"Position"] unsignedIntegerValue];
	SEXP orig;
	SEXP vec = orig = (SEXP)[(NSValue*)[desc objectForKey:@"SEXP"] pointerValue];
	NSLog(@"Setting argument at position %ld",(long)pos);
	do {
//		Rf_PrintValue(vec);		
		if(i==pos) {
			SETCAR(vec,(SEXP)[value pointer]);
			break;
		}
		vec = CDR(vec);
		i++;
	} while(vec != NULL);
//	Rf_PrintValue(orig);
}

- (NSUInteger)count {
	return [args count];
}

- (NSString*)description {
	return [NSString stringWithFormat:@"<%@: 0x%x> {%ld arguments}",NSStringFromClass([self class]),self,(long)[self count]];
}

@end
